package collections;

import java.util.concurrent.ArrayBlockingQueue;
import java.util.concurrent.TimeUnit;

public class TestBlockingQueue
{
    static final int count = 3; 
    ArrayBlockingQueue<String> queue
        = new ArrayBlockingQueue<String>(count);

    public class Consumer extends Thread
    {       
        @Override
        public void run()
        {
            while(true)
            {
                try
                {
                    System.out.println("Consumer waiting for request");
                    String s = queue.take();
                    System.out.println("Consumer got a request: " + s);
                }
                catch (InterruptedException e)
                {
                    e.printStackTrace();
                }
            }
        }
    }
    public static void main(String[] args)
        throws Exception
    {
        TestBlockingQueue tbq = new TestBlockingQueue();
        Consumer consumer = tbq.new Consumer();

        for(int i = 1; i <= count+1; i++)
        {
            String s = "String " + i;
            boolean added = tbq.queue.offer(
                    s, 3000, TimeUnit.MILLISECONDS);
            if (added == false)
                System.out.println(
                    "Add timed out for String " + i);
        }
        consumer.start();
    }
}
